--01.) declare vars in RAM in order tot access them before they are initialized
TexTools_version_nr = "4.10";--the version number

fn_00__save_load_settings;--to save and load for the first time later

rl_install;
rl_uninstall;
rl_setup;
setup_textools_uninstall_step1;
setup_textools_install;
setup_textools_quit;
setup_textools_uninstall_getList;
setup_textools_install_manually;

--02.) try to kill previous floaters
try (--close if possible
	DestroyDialog rl_install;
) catch();
try (--close if possible
	DestroyDialog rl_uninstall;
) catch();
try (--close if possible
	DestroyDialog rl_setup;
) catch();
try (
	DestroyDialog rl_textureTools;
) catch();
try (
	DestroyDialog rl_texTools_bake;
) catch();
try (--close if possible
	DestroyDialog rl_TexTools_options;
) catch();
try (
	DestroyDialog rl_texTools_transform;
)catch();
--03.) functions used for the setup (Install, Uninstall)

function setup_textools_update prct msg=(
	rl_install.pb_bar.value = prct;--0 - 100
	rl_install.txt_stats.text = msg as string;--update message
)

function setup_textools_install_manually = (
	local m =  "It appears that your temporary folder is not accessable\rto extract the files from the MZP file. Or there is no permission\rto copy files to the userDirectories. So if you keep\nseeing this message please install TexTools manually with\rthe following steps:\r"
	m+="\n\n1.) Rename the TexTools '.mzp' extention to '.zip' and open\rit with Winzip, Winrar or whatever."
	m+="\n\n2.) Copy the 'TexTools' folder with its content to the userScripts folder."
	m+="\ni.e.: "+"C:\Documents and Settings\Hendrik\Local Settings\Application Data\Autodesk\3dsmax\2010 - 32bit\enu\scripts";
	m+="\n\n3.) Copy the content of the 'Icons' folder to the userIcons folder."
	m+="\ni.e.: "+"C:\Documents and Settings\Hendrik\Local Settings\Application Data\Autodesk\3dsmax\2010 - 32bit\enu\UI\usericons";
	m+="\n\n4.) Within 3dsmax open the Maxscript Listener (F11 key) and choose File > Run Script...\rand browse to the scripts/TexTools (userscript folder) to choose the 'TexTools_3.80.ms' file"
	m+="\ni.e.: "+"C:\Documents and Settings\Hendrik\Local Settings\Application Data\Autodesk\3dsmax\2010 - 32bit\enu\scripts\TexTools\TexTools_3.80.ms";
	m+="\n\n\nFor more help goto:\nhttp://www.renderhjs.net/textools"
	messageBox m title:"Manual Installation Guide" beep:false;
)



function setup_textools_find_MZP_url =(
	local url = sysInfo.tempdir as string;
	local folders = getDirectories (url+"mzptmp*");--temporay MZP folders
	
	local _mathchUrls = #();--store possible matches and have them sort by date later
	local _matchDates = #();
	local _pCnt = 0.0;
	for f in folders do (
		_pCnt+=1.0;
		--find the right folder and file from theh MZP archive
		local  has_folder= getDirectories (f+"TexTools");
		local  has_mzp= getFiles (f+"mzp.run");
		
		local p = _pCnt / folders.count* 18.0;
		--setup_textools_update p ("scan "+f);
		
		if (has_folder.count == 1 and has_mzp.count == 1)then(
			local _date = getFileCreateDate has_mzp[1];
		
			append _matchDates _date;
			append _mathchUrls f;
		
			print("matching folder\t: "+(getFilenamePath f)+" \tcreated: "+_date as string);
		)
	)
	
	if (_mathchUrls.count > 0)then(
		--found some urls that match our footprint, now sort by date and pick the latest
		local _new = amax _matchDates;--the latest date item
		local _indx = findItem _matchDates _new;
		local final_url = _mathchUrls[_indx];
		print(_indx as string+".\t\tnewest "+final_url);
		return final_url;
	)else(
		return "";
	)
)
function setup_textools_quit =(
	--clearlistener();
	print("Quitting the setup (deleting left over MZP files)");
	--delete temporary MZP files (3dsmax generated them, not this script)
	local final_url = setup_textools_find_MZP_url();
	if (final_url != "")then(
		
		
		--generate a list of files to delete
		local del_folders =#();
		local del_files =#();
		
		local folders = getDirectories (final_url+"*");--temporay MZP folders
		for f in folders do (
			append del_folders f;
			
			local files = getFiles (f+"\\*");--delete files inside this folder before we can delete the folder
			for fl in files do (
				append del_files fl;
			)
			local files = getDirectories (f+"\\*");--delete files inside this folder before we can delete the folder
			for fldr in files do (
				local files2 = getFiles (fldr+"\\*");--delete files inside this folder before we can delete the folder
				for fl in files2 do (
					append del_files fl;
				)
			)
		)
		append del_folders final_url;
		----
		for s in del_files do (
			--files
			local _done = deleteFile s;
			--format ("\t"+s+", done: "+_done as string+"\n");
			--format ("\tdel f: "+s+", delete: \n");
		)
		for s in del_folders do (
			local str = "rmdir \""+s+"\"";
			local _done;
			hiddendoscommand str startpath:"$max" exitCode:&_done
			--format (str+"\t\tdone: "+_done as string+"\n");
			--format ("\tdel d: "+s+", delete: \n");
		)
	)
)
function setup_textools_install =(
	--clearlistener();
	
	try (--close if possible the existing Toolbar interface
		DestroyDialog rl_textureTools;
	) catch();

	setup_textools_update 0 "init install";
	local final_url = setup_textools_find_MZP_url();
	if (final_url != "")then(
		setup_textools_update 20 "found MZP files";
		
		--prepare to copy files
		local _scriptDir = pathConfig.GetDir #userScripts+"\\TexTools";
		local accessFolder = makeDir _scriptDir;
		if (accessFolder == true)then(
			

			local failing = false;
			
			setup_textools_update 25 "Create '/scrits/TexTools' folder";
			
			local _filesSource = getFiles (final_url+"\\TexTools\\*");

			local _pCnt = 0.0;
			for sf in _filesSource do (
				_pCnt+=1.0;

				
				local tf = _scriptDir+"\\"+filenameFromPath sf;
				
				local accessFile = deleteFile tf;--try to delete the icons if they can not be replaced below
				local accessFile = copyFile sf tf;
				
				if (accessFile == true)then(
					local p = (_pCnt / _filesSource.count) * 50.0+25.0;
					setup_textools_update p ("copy to '\scripts\TexTools' file "+sf as string);
					print("copy files..."+sf as string);
				)else(
					setup_textools_update 0 "Error, can't copy files to the '/userScripts/TexTools' folder";
					print("fail..");
					failing = true;
				)
			)
			
			
			if (failing == false)then(

				--local _iconDir = pathConfig.GetDir #ui+"Icons";
				local _iconDir = pathConfig.GetDir #userIcons;
				
				local _filesSource = getFiles (final_url+"Icons\\*");
				
				
				local _pCnt = 0.0;--percentage count
				for sf in _filesSource do (--source file
					_pCnt+=1.0;
					
					local tf = _iconDir+"\\"+filenameFromPath sf;--target file
					
					local accessFile = deleteFile tf;--try to delete the icons if they can not be replaced below
					local accessFile = copyFile sf tf;
					
					if (accessFile == true)then(
						local p = (_pCnt / _filesSource.count) * 20.0+75.0;
						setup_textools_update p ("copy to '\ui\Icons' file "+_pCnt as string+"/"+_filesSource.count as string);
					)else(
						setup_textools_update 0 "Error, can't copy Icons to the '/userIcons' folder";
						failing = true;
					)
				)
				
				if (failing == false)then(
					--no file access issues so far, now we should be able to launch texTools
					
					setup_textools_update 95 "reload 3dsmax toolbar Icons (max9+)";
					if ((maxVersion())[1] >= 9000 )then(
						colorman.reInitIcons();--after the icons are copied to the UI folder, reload Max Toolbar icons so that the texToolbar icon is visible (max bug)
					)else(
						messageBox "Because you have an older version of max (below version 9) you need to restart max\nin order to see TexTools icons on the main tollbar, that is should you drag TexTools in the main toolbar." title:"Restart Max" beep:false;
					)
					
					setup_textools_update 98 "starting TexTools...";
					
					
					
					setup_textools_update 100 "installation was succesfull!";
					
					CreateDialog rl_setup;
					
					try (--close if possible
						DestroyDialog rl_install;--this is the last step and it will delete the left over MZP files
					)catch();
					
					local startFile = _scriptDir+"\\TexTools_3.80.ms"
					fileIn startFile;--start TexTools
					
					--save settings for the first time with the default values
					if (fn_00__save_load_settings == undefined)then(
						fileIn ((_scriptDir+"\\fn_00__save_load_settings.ms") as string);
					)
					fn_00__save_load_settings false;
					fn_00__save_load_settings true;--now load the values
					
				)
			)
			
		)else(
			setup_textools_update 0 "Error, no writing rights within your '/userscripts' folder.\nPoked around with some settings in 3dsMax?";
			setup_textools_install_manually();
		)
	)else(
		setup_textools_update 0 "Error, no temporary MZP files found:\nRedrag the MZP file into the viewport and install again.";
		setup_textools_install_manually();
	)
)


function setup_textools_uninstall_getList =(
	
	--generate a list of files to delete
	local del_folders =#();
	local del_files =#();
	
	local mzpFolder = setup_textools_find_MZP_url();--get the current MZP folder
	
	--clearlistener();
	local folders = getDirectories (sysInfo.tempdir+"mzptmp*");--temporay MZP folders
	for f in folders do (
		local  has_folder= getDirectories (f+"TexTools");
		local  has_mzp= getFiles (f+"mzp.run");
		if (has_folder.count == 1 and has_mzp.count == 1)then(--mark this folder to be deleted
			
			local dirA = getFilenamePath mzpFolder;
			local dirB = getFilenamePath f;
			
			
			if (dirA == dirB)then(
				print("EXCLUDE ");
			)else(
				print("NOT");
				append del_folders f;
			
				local files = getFiles (f+"\\*");--delete files inside this folder before we can delete the folder
				for fl in files do (
					append del_files fl;
				)
				local files = getDirectories (f+"\\*");--delete files inside this folder before we can delete the folder
				for fldr in files do (
					local files2 = getFiles (fldr+"\\*");--delete files inside this folder before we can delete the folder
					for fl in files2 do (
						append del_files fl;
					)
				)
				
				
			)
		)
	)
	--fheck for the scripts/texTools folder
	local  has_folder= getDirectories ((pathConfig.GetDir #scripts)+"\\TexTools");
	if (has_folder.count == 1)then(--mark this folder to be deleted
		append del_folders has_folder[1];
		local files = getFiles (has_folder[1]+"\\*");--delete files inside this folder before we can delete the folder
		for f in files do (
			append del_files f;
		)
	)
	local  has_folder= getDirectories ((pathConfig.GetDir #userScripts)+"\\TexTools");
	if (has_folder.count == 1)then(--mark this folder to be deleted
		append del_folders has_folder[1];
		local files = getFiles (has_folder[1]+"\\*");--delete files inside this folder before we can delete the folder
		for f in files do (
			append del_files f;
		)
	)
	
	
	--usermacro files
	local files = getFiles ((pathConfig.GetDir #userMacros)+"\\TexTools*");--temporay MZP folders
	for f in files do (
		append del_files f;
	)
	--ini setting file
	local iniFile =(pathConfig.GetDir #userScripts)+"\\texTools.ini";
	if ( doesFileExist iniFile)then(
		append del_files iniFile;
	)
	--icon files
	local files = getFiles ((pathConfig.GetDir #ui+"Icons")+"\\TexTools*");
	for f in files do (
		append del_files f;
	)
	local files = getFiles ((pathConfig.GetDir #userIcons)+"\\TexTools*");
	for f in files do (
		append del_files f;
	)
	return #(del_files, del_folders)
)



function setup_textools_uninstall_step2=(
	
	local list = setup_textools_uninstall_getList();
	print("Uninstall");
	
	for s in list[1] do (
		--files
		local _done = deleteFile s;
		--format ("\t"+s+", done: "+_done as string+"\n");
	)
	for s in list[2] do (
		local str = "rmdir \""+s+"\"";
		local _done;
		hiddendoscommand str startpath:"$max" exitCode:&_done
		--format (str+"\t\tdone: "+_done as string+"\n");
	)
	
	if (list[1].count == 0 and list[2].count == 0)then(
		--go back
		try (--close if possible
			DestroyDialog rl_uninstall;
		) catch();
		CreateDialog rl_install bgcolor:(color 32 32 32);
		
	)else(
		setup_textools_uninstall_step1();
	)
	
	print("Done "+setup_textools_uninstall_step1 as string);
)


function setup_textools_uninstall_step1=(
	local list = setup_textools_uninstall_getList();
	print("........list ;."+list[1].count as string);
	
	--create dropdown list array
	local list2 = #();
	for f in list[2] do(
		append list2 ("folder: "+ f)
	)
	for f in list[1] do(
		append list2 ("file:   "+filenameFromPath  f)
	)
	
	--print(" GUI "+rl_uninstall as string);
	
	rl_uninstall.lbx_list.items = list2;
	if (list2.count == 0)then(
		rl_uninstall.lbl_message.text = ("You have no TexTools files left on your System :)");
		rl_uninstall.btn_uninstall.caption = "Back";
	)else(
		rl_uninstall.lbl_message.text = ("Are yout sure to delete these "+list[2].count as string+" folder(s) and "+list[1].count as string+" file(s)?");
	)
)


---------------------
rollout rl_setup "Installation complete" width:280 height:356
(
	label lbl2 "The installation was completed succesfully. Use this Setup to start TexTools next time after your next 3dsMax start." pos:[3,312] width:270 height:42
	
	button btnBmp pos:[0,0] width:280 height:310;
	on rl_setup open do(
		--if( maxVersion())[1] <= 9000 )then(
			btnBmp.images = #("setup.bmp", "setup.bmp", 1,1,1,1,1,false);
		/*)else(--max 2010
			btnBmp.images = #("setup.bmp", "setup.bmp", 1,1,1,1,1,false,false);
		)*/
		rl_setup.title ="TexTools "+TexTools_version_nr as string+" was installed";
	)
	
	on btnBmp pressed do
	(
		try (--close if possible
			DestroyDialog rl_setup;
		) catch();
	)
)
---------------------
rollout rl_uninstall "Uninstall" width:280 height:312
(
	button btn_uninstall "Uninstall" pos:[4,246] width:274 height:32
	progressBar pb_bar "ProgressBar" pos:[5,280] width:274 height:15 color:[190,10,30]
	label txt_stats "" pos:[7,297] width:270 height:14
	MultiListBox  lbx_list "" pos:[2,18] width:280 height:17 readOnly:true;
	label lbl_message "..." pos:[3,3] width:280 height:14
	on btn_uninstall pressed do
	(
		setup_textools_uninstall_step2();
	)
	on rl_uninstall close do(
		print("You closed the uninstall...");
		try (--close if possible
			DestroyDialog rl_uninstall;
		) catch();
		CreateDialog rl_install bgcolor:(color 32 32 32);
	)
)
---------------------
rollout rl_install "" width:280 height:206
(
	button btn_install "Quick Install" pos:[0,32] width:140 height:32
	button btn_uninstall "Uninstall..." pos:[140,32] width:140 height:32
	button btn_userFolder "Open UserScript Folder" pos:[140,116] width:140 height:32

	
	progressBar pb_bar "ProgressBar" pos:[3,67] width:274 height:15 color:[190,10,30]
	
	bitmap bmp1 "Bitmap" pos:[0,0] width:280 height:32 fileName:"install.bmp"
	

	
	
	label txt_stats "Click 'Quick Install' to install TexTools to your userscript folder. TexTools will start straight after the installation." pos:[4,86] width:270 height:28

	label lbl11 "Online Links:" pos:[5,138] width:129 height:15
	HyperLink lnk1 "Official Site with Help" pos:[6,155] width:129 height:15 color:(color 96 106 92) hovercolor:(color 112 138 59) address:"http://www.renderhjs.net/textools/"
	HyperLink lnk2 "Polycount.net Discussion" pos:[6,170] width:129 height:15 color:(color 96 106 92) hovercolor:(color 112 138 59) address:"http://boards.polycount.net/showthread.php?t=69736"
	HyperLink lnk3 "Youtube Learning Videos" pos:[140,155] width:135 height:15 color:(color 96 106 92) hovercolor:(color 112 138 59) address:"http://www.youtube.com/view_play_list?p=0D7878B0B79B344E"
	HyperLink lnk4 "Amazon Donation List" pos:[140,170] width:129 height:15 color:(color 96 106 92) hovercolor:(color 112 138 59) address:"http://amzn.com/w/NQJTN1P2IJ0Q"
	
	HyperLink lnk5 "ScriptSpot.com Entry" pos:[6,186] width:135 height:15 color:(color 96 106 92) hovercolor:(color 112 138 59) address:"http://www.scriptspot.com/3ds-max/scripts/textools-toolbox-for-the-texture-artist"
	HyperLink lnk6 "Optional RoadKill Download" pos:[140,186] width:135 height:15 color:(color 96 106 92) hovercolor:(color 112 138 59) address:"http://www.pullin-shapes.co.uk/page8.htm"

	
	on rl_install close do
	(
			local visUninstall = rl_uninstall.open;
			
			if (visUninstall == false)then(--only delete the MZP files if no other essential setup floaters are visible
				setup_textools_quit();--delete any MZP temporay left files
				gc();
			)
		)
	on btn_install pressed do
	(
			setup_textools_install();
		)
	on btn_uninstall pressed do
	(
		CreateDialog rl_uninstall 280 316;
		setup_textools_uninstall_step1();
		try (--close if possible
			DestroyDialog rl_install;
			rl_install
		) catch();
	)
	on btn_userFolder pressed do(
		local url =getdir #userScripts;
		shellLaunch "explorer.exe" url;
	)

)



CreateDialog rl_install;--bgcolor:(color 32 32 32)
rl_install.title = "TexTools "+TexTools_version_nr+" Setup";
if ((maxVersion())[1] <= 8000 )then(--max 8 or older
	messageBox "3dsmax 8 and older is not supported in most\nof the functions of this project.\n\nYou can however dig in the scripts yourself\nas each function is stored in a seperate scriptfile\nso it should be easy to debug them and perhaps\nmake them compatible yourself ;)\nThe toolbar will most certainly not initialize so\nhave a look at the individual scripts instead" title:"Warning, to old 3dsMax version" beep:false;
)else if ((maxVersion())[1] <= 9000 )then(--max 9
	messageBox "For 3dsMax 9 users there is no support for\nmulti object unwrap and a few other tools\nsuch as peel mapping.\nBut most of the things should work for you." title:"3dsMax 9 info"beep:false;
)